**********************************************************************
**   DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO * DEMO   **
**********************************************************************
**   INCLUDE ZSS_12                                                 **
**********************************************************************
**                                                                  **
**                            RBarc+                                **
**                       for SAPScript                              **
**                             V12                                  **
**                Copyright (C) 2007-2016 Suchy MIPS                **
**                      All rights reserved                         **
**                                                                  **
**********************************************************************
**  Serial No.: DEMO                                                **
**********************************************************************
**                     NOT FOR PRODUCTIVE USE!!!                    **
**********************************************************************
**  This is a part of RBarc+,                                       **
**  a Suchy MIPS Bar Code solution for SAP Systems                  **
**  This program is protected by copyright.                         **
**  No parts of this program may be changed, copied or reproduced.  **
**  WARRANTY VOID IF ANY CHANGES WILL BE DONE IN THIS FILE          **
**                                                                  **
**  Suchy MIPS shall not be liable for errors contained herein or   **
**  for incidental consequential damages in connection with use of  **
**  this program.                                                   **
**                                                                  **
**  THIS PROGRAM SHELL BE INSTALLED IN THE TEST ENVIRONMENT         **
**  AND TESTED BEFORE USING ON THE PRODUCTIVE SYSTEM                **
**                                                                  **
**  Suchy MIPS GmbH                                                 **
**  Prinzregentenstrae 128                                         **
**  81677 Muenchen                                                  **
**  Germany                                                         **
**  Phone:   +49-89-944 19 77 - 0                                   **
**  Fax:     +49-89-944 19 77 - 13                                  **
**  E-mail   info@suchymips.de                                      **
**                                                                  **
**********************************************************************
**********************************************************************
**  Released: 16.05.2013                                            **
**  Version:  12                                                    **
**  Release:  12.0.1                                                **
**********************************************************************
**********************************************************************


FORM PRINT_BARCODE USING BARCODE TYPE C $VALUE W_CHKSUM TYPE C
                     $B TYPE I $BB TYPE I $BBB TYPE I $BBBB TYPE I
                     $W TYPE I $WW TYPE I $WWW TYPE I $WWWW TYPE I
                     BARC_HIGH XPOSITION YPOSITION $ROT TYPE I
                     $SIGN TYPE I MASK TYPE C FONT TYPE C MARGIN
                     OFFSET LENGTH UNIT TYPE C
                     ST_TEXT_NAME TYPE C D1 D2 D3 D4 $RES
                     T1 T2 I1 I2
                   CHANGING SMV1 SMV2 SMV3 GCHECKSUM VALUE mtype
                     RT1 RT2 RI1 RI2.


  DATA BEGIN OF LINES OCCURS 0.
          INCLUDE STRUCTURE TLINE.
  DATA END OF LINES.

  DATA BEGIN OF HEADER OCCURS 0.
          INCLUDE STRUCTURE THEAD.
  DATA END OF HEADER.
  DATA: CODE(500), TAIL(100), GCODE(600),
        c_len type i, t_len type i, gc_len type i,
        N TYPE I, K TYPE I VALUE 0, P TYPE I, GAP TYPE I,
        L TYPE I, ST(10), OFFSET1 TYPE I,
        PRNCTRL(10), II TYPE I,
        WSP TYPE F, ERR_CODE TYPE I, ERR_VAL TYPE STRING,
        C0, C1, C2(2), MACRO(4),
        TBCODE(20), ID,
        STR(500), SEQ(20),
        SLINE(132), FLAG,
        FSTR(100), CHKS(5),
        XPOS TYPE I, YPOS TYPE I,
        HIGH TYPE I, HIGH1 TYPE I, LEN TYPE I, MARG TYPE I,
        XPOS1 TYPE I VALUE 0, YPOS1 TYPE I VALUE 0,
        XPOS2 TYPE I VALUE 0, YPOS2 TYPE I VALUE 0,
        GR TYPE I, TEXT_NAME(20),
        BARLEN TYPE I VALUE 0,
        BARLEN_NO_TAIL TYPE I,
        BARLEN0 TYPE I,
        BARLEN1 TYPE I VALUE 0,
        C TYPE I, CC TYPE I, X TYPE I, XX TYPE I, MYCNT LIKE SY-TVAR9,
        UNAME1 LIKE SY-UNAME, UNAME2 LIKE SY-UNAME, U1, UL TYPE I,
        last_row(132), res type i, g_type type string,
        margin_pix type i,
        offset_pix type i,
        sign type i,
        $barc_high type F,

        c_exp(65535),
        gc_exp_save(65535),
        c_exp_rot(65535),
        c_exp_1(65535),
        c_exp_0(65535),
        c_hex(65535),
        c_hex_1(65535),
        c_hex_0(65535),
        gc_exp(65535),
        gc_exp_rot(65535),
        gc_exp_1(65535),
        gc_exp_0(65535),
        gc_hex(65535),
        gc_hex_len type i,
        gc_hex_1(65535),
        gc_hex_0(65535),
        t_exp(65535),
        top_exp(65535),
        top_hex(65535),
        term_exp(65535),
        term_hex(65535),
        er_exp(65535),
        bm_rot type string,

        marg_exp(65535),
        marg_exp_rot(65535),
        marg_hex(65535),
        marg_hex_len type i,


        bitmap_header(132),
        bitmap_len type i,
        bit_len type i,
        bit_len_orig type i,
        bytes_per_row type i,
        Br type i,
        BBr type i,
        BBBr type i,
        BBBBr type i,
        Wr type i,
        WWr type i,
        WWWr type i,
        WWWWr type i,
        r_body,
        r_marg,
        r_top,
        r_term,
        $$$c_hex type string,
        pad type i,
        c_rot type string,

        offs type i,
        offs_m type i,
        offs_t type i,
        er_cnt type i,

        rest type i,
        halfbyte,
        eads_w(32),
        eads_s(32),

        sbb type i,
        sbb_x(500),
        sbb_xl type i,
        bterm,
        btermh type i,
        body_h type i,
        top_h type i,
        marg_h type i,
        term_h type i,
        padding type i,
        4Bytes type i,

        err1 type string,
        err2 type string,
        err3 type string,
        err4 type string,
        err type string,
        B type i,
        BB type i,
        BBB type i,
        BBBB type i,
        w type i,
        ww type i,
        www type i,
        wwww type i,
        bcende type i,
        $ERROR_HANDLING type i,
        $INPUT_HANDLING type i.

data: begin of dbitmap occurs 0,
         l(1000),
      end of dbitmap.
*tables: zrbarc.

data: M1(100), M1b(100), M1c(100),
      M2(100),
      M3(100),
      M4(100), M4b(100).


if sy-tvar7 is initial.

 AUTHORITY-CHECK OBJECT 'S_BDS_DS'
                  ID 'ACTVT' FIELD '02'
                  ID 'ACTVT' Field '06'
                  ID 'CLASSNAME' FIELD 'DEVC_STXD_BITMAP'
                  ID 'CLASSTYPE' FIELD 'OT'.

 IF sy-subrc <> 0.
 M1 ='Missing authorisation for object "S_BDS_DS" for user "'.
M1b = sy-uname.
M1c = '".'.
Concatenate M1 M1b M1c into M1.
M2 = 'Correct it eg. with transaction "US01".'.
*M3 = 'ACTVT = 02 & 06| CLASSNAME = DEVC_STXD_BITMAP | CLASSTYPE = OT'.
M3 = 'Activities 02 and 06 are required.'.
M4 = '"S_BDS_DS" is assigned to class "Basis-Central functions".'.
M4b = '** Programm aborted!**'.
Concatenate M4 M4b into M4.
   CALL FUNCTION 'POPUP_TO_INFORM'
   EXPORTING
    TITEL              = 'RBarc+: Missing authorisation!'
    TXT1          = M1
    TXT2          = M2
    TXT3          = M3
    TXT4          = M4.
   exit.
 ELSE.
  sy-tvar7 = 9. "=OK
 ENDIF.
 endif.




*-------- MAKRA ------*
  DEFINE PISZ.
    L = STRLEN( &1 ).
    DO L TIMES.
      C1 = &1.
      IF C1 BETWEEN '0' AND '9'.
        CONCATENATE '3' C1 INTO C2.
      ELSE.
        PERFORM CHARTOHEX USING C1 CHANGING C2.
      ENDIF.
      IF II < 130.
        WRITE C2 TO SLINE+II.
        II = II + 2.
      ELSE.
        LINES-TDLINE = SLINE.
        APPEND LINES.
        WRITE C2 TO SLINE.
        II = 2.
      ENDIF.
      SHIFT &1.
    ENDDO.
  END-OF-DEFINITION.
*-------- MAKRO DO WPISYWANIA DO LINIJKI
  DEFINE PISZ_HEX.
    L = STRLEN( &1 ). K = L + II.
    IF  K  > 130.
      LINES-TDLINE = SLINE.
      APPEND LINES.
      SLINE = ''. II = 0.
    ENDIF.
    WRITE &1 TO SLINE+II.
    II = II + L.
  END-OF-DEFINITION.
*------ MAKRO DO POZYCJONOWANIA bezwzglednego -----*
  DEFINE POZYCJONUJ.
    PISZ_HEX '1B2661'.
    WRITE &1 TO ST USING EDIT MASK 'LL________________________________'.
    PISZ ST.
    PISZ_HEX '68'.
    WRITE &2 TO ST USING EDIT MASK 'LL________________________________'.
    PISZ ST.
    PISZ_HEX '56'.
  END-OF-DEFINITION.
* ----- pozycjonowanie wzgledne x - horyzontalne, y - wertykalne
* ----- p - plus, m - minus
  DEFINE POZYCJONUJ_WZGL.
    IF &2 = 'p'.
      PRNCTRL = '1B26612B'.
    ELSEIF &2 = 'm'.
      PRNCTRL = '1B26612D'.
    ENDIF.
    PISZ_HEX PRNCTRL.
    WRITE &3 TO ST USING EDIT MASK 'LL___________________________'.
    PISZ ST.
    IF &1 = 'x'.
      PRNCTRL = '48'.
    ELSEIF &1 = 'y'.
      PRNCTRL = '56'.
    ENDIF.
    PISZ_HEX PRNCTRL.
  END-OF-DEFINITION.

*--------- MAKRO DO RYSOWANIA PROSTOKACIKA -----------------*
  DEFINE PROSTOKAT.
    PISZ_HEX '1B2A63'.
    WRITE &1 TO ST USING EDIT MASK 'LL________________________________'.
    PISZ ST.
    PISZ_HEX '68'.
    WRITE &2 TO ST USING EDIT MASK 'LL________________________________'.
    PISZ ST.
    PISZ_HEX &3.                         "wype#nienie
  END-OF-DEFINITION.
*----- Push cursor
  DEFINE PUSH_CURSOR.
    PISZ_HEX '1B26663053'.
  END-OF-DEFINITION.
*------ Pop cursor
  DEFINE POP_CURSOR.
    PISZ_HEX '1B26663153'.
  END-OF-DEFINITION.
*--------- Define macro
  DEFINE MACRO_DEF.
    IF &5 = 'p'.
      PISZ_HEX '1B2666'.
    ENDIF.
* SM 14.11.1999 SHIFT MACOR NO.
    IF D2 <> '0'.
      PISZ_HEX D2.
    ENDIF.
    PISZ_HEX &1. PISZ_HEX '793058'.
    PROSTOKAT &2 &3 '763050'.
    POZYCJONUJ_WZGL 'x' 'p' &4.
    IF &5 = 'l'.
      PISZ_HEX '1B26663158'.
    ELSE.
      PISZ_HEX '1B26663178'.
    ENDIF.
  END-OF-DEFINITION.
*------ Grubosc paska
  DEFINE BAR_THICK.
    CASE &1.
      WHEN 'b'.
        GR = B. C1 = '4'.
      WHEN 'B'.
        GR = BB. C1 = '5'.
      WHEN 'w'.
        GR = W. C1 = '1'.
      WHEN 'W'.
        GR = WW. C1 = '2'.
      WHEN 'c'.
        GR = C. C1 = '6'.
      WHEN 'C'.
        GR = CC. C1 = '7'.
      WHEN 'x'.
        GR = X. C1 = '3'.
      WHEN 'X'.
        GR = XX. C1 = '4'.
    ENDCASE.
    BARLEN = BARLEN + GR.
  END-OF-DEFINITION.
*---------- Draw_barcode
  DEFINE DRAW_BARCODE.
    PISZ_HEX '1B2666'.
*SM 14.11.1999 no more macro 11
    N = STRLEN( &1 ) MOD 2.
    IF N <> 0.
      CONCATENATE &1 'w' INTO STR.
    ELSE.
      STR = &1.
    ENDIF.
    N = STRLEN( STR ) / 2.
    DO N TIMES.
      C2 = STR.
      SHIFT STR BY 2 PLACES.
      C0 = C2. MACRO = '3'.
      BAR_THICK C0.
      WRITE C1 TO MACRO+1.
      C0 = C2+1.
      BAR_THICK C0. WRITE '3' TO MACRO+2.
      WRITE C1 TO MACRO+3.
*SM 14.11.1999 shift Macro No.
      IF D2 <> '0'.
        PISZ_HEX D2.
      ENDIF.
      PISZ_HEX MACRO. PISZ_HEX '793378'.
   ENDDO.                               "przewijanie specyfikacji paskw
    PISZ_HEX '3059'.
  END-OF-DEFINITION.
*------------- draw_barcode

*------- Main program

  $error_handling = error_handling mod 10.
  $input_handling = input_handling mod 10.

  hde = ( error_handling mod 100 - $error_handling ) div 10.
  the = ( error_handling mod 1000 - $error_handling - hde ) div 100.
tte = ( error_handling mod 10000 - $error_handling - tte - c ) div 1000.

  hdi = ( input_handling mod 100 - $input_handling ) div 10.
  thi = ( input_handling mod 1000 - $input_handling - hdi ) div 100.
tti = ( input_handling mod 10000 - $input_handling - tti - c ) div 1000.

*-------Barcode Name
*   patch from 23.08.2007
*   during paralell processing it can happen
*   that the name is not uniqe. This causes
*   a deadlock. Now we use a much more accurat timestamp
*   for generating the TEXT_NAME.
data: bc_time type timestampl,
      bc_time_compr(23),
      encoding_value(40),
      checkresult.
   get time stamp field bc_time.
   write bc_time to bc_time_compr.
   checkresult = ''.
   while checkresult = ''.
     replace '.' with ''  into bc_time_compr .
     if sy-subrc > 0.
       checkresult = 'X'.
     endif.
   endwhile.
   checkresult = ''.
   while checkresult = ''.
     replace ',' with ''  into bc_time_compr .
     if sy-subrc > 0.
       checkresult = 'X'.
     endif.
   endwhile.


   condense bc_time_compr no-gaps.
   shift bc_time_compr by 8 places left.

   write $value to encoding_value.

   checkresult = ''.
   while checkresult = ''.
     replace ',' with ''  into encoding_value .
     if sy-subrc > 0.
       checkresult = 'X'.
     endif.
   endwhile.

  checkresult = ''.
   while checkresult = ''.
     replace '*' with ''  into encoding_value .
     if sy-subrc > 0.
       checkresult = 'X'.
     endif.
   endwhile.



*   replace all occurrences of ',' in encoding_value with ''.
*   replace all occurrences of '*' in encoding_value with ''.

   condense encoding_value no-gaps.

    TEXT_NAME = ST_TEXT_NAME.
    TRANSLATE TEXT_NAME TO UPPER CASE.
    SY-TVAR9 = SY-TVAR9 + 1.
    MYCNT = SY-TVAR9.

    SHIFT MYCNT LEFT DELETING LEADING '0'.
    SHIFT MYCNT LEFT DELETING LEADING SPACE.

    UNAME1 = SY-UNAME.
    UNAME2 = ''.
    TRANSLATE UNAME1 TO UPPER CASE.
    UL = STRLEN( UNAME1 ).
    DO UL TIMES.
      U1 = UNAME1.
      IF U1 NA 'ABCDEFGHIJKLMNOPQRSTUVWXAZ0123456789'.
        SHIFT UNAME1.
      ELSE.
        CONCATENATE UNAME2 U1 INTO UNAME2.
      ENDIF.
      SHIFT UNAME1.
    ENDDO.

*    CONCATENATE 'ZRB' TEXT_NAME uname2 bc_time_compr
*                  MYCNT encoding_value INTO SMV1.

    concatenate
      'ZRB'
      bc_time_compr
      mycnt
      encoding_value
      text_name
      uname2
    INTO
      smv1.

*----------------- Zamiana jednostek
    data: esc_len type i,
        res_len type i.
  ERR_VAL = ''.
  if $res le 0.
    esc_len = strlen( D4 ).
    if esc_len > 6.
      res_len = esc_len - 6.
      if res_len > 0.
        res = D4+6(res_len).
      endif.
    else.
      err1 = 'ERROR: Resolution is not a positive value.'.
      err2 = '  I am going to set it automatically to "150".'.
      err3 = '  Contact the ADMINISTRATOR for correcting '.
      err4 = '  this problem.'.
      concatenate err1 err2 err3 err4 into err.
      if $error_handling = 0.
        message err type mtype.
      endif.
      Err_code = 1.
      err_val = err.
      res = 150. "defult
    endif.
  else.
    res = $res.
  endif.

  g_type = D4(6).
    ST = UNIT.
    TRANSLATE ST TO UPPER CASE.
    IF NOT ( ST = 'CM' OR ST = 'MM' OR ST = 'INCH' ).
     err1 = 'ERROR: Wrong UNIT type: '.
     err2 = Unit.
     err3 = '  I am going to set it automatically to "mm". '.
     err4 = '  Contact the ADMINISTRATOR for correcting this problem.'.
     concatenate err1 err2 err3 err4 into err.

     if $error_handling = 0.
       message err type mtype.
     endif.
     ERR_CODE = 1.
     ERR_VAL = err.
     ST = 'MM'.
    ENDIF.
    CASE ST.
      WHEN '"'.
        WSP = res.
      WHEN 'INCH'.
        WSP = res.
      WHEN 'MM'.
        WSP = res / '25.4'.
      WHEN 'CM'.
        WSP = res / '2.54'.
      WHEN OTHERS.
        WSP = 1.
    ENDCASE.
* ------ ERROR HANDLING
  IF XPOSITION ge 0.
    XPOS = WSP * XPOSITION.
  ELSE.
    err1 = 'ERROR: XPOS is negative: '.
    err2 = XPOS.
    err3 = '  I am going to set it automatically to the value "O". '.
    err4 = '  Contact the ADMINISTRATOR for correcting this problem. '.
    concatenate err1 err2 err3 err4 into err.
    if $error_handling = 0.
      message err type mtype.
    endif.
    Err_Code = 1.
    err_val = err.
    XPOS = 0.
  ENDIF.
  IF YPOSITION ge 0.
    YPOS = WSP * YPOSITION.
   ELSE.
    err1 = 'ERROR: YPOS is negative: '.
    err2 = YPOS.
    err3 = '  I am going to set it automatically to the value "O". '.
    err4 = '  Contact the ADMINISTRATOR for correcting this problem.'.
    concatenate err1 err2 err3 err4 into err.
    if $error_handling = 0.
      message err type mtype.
    endif.
    Err_Code = 1.
    err_val = err.
    YPOS = 0.
  ENDIF.
  IF BARC_HIGH gt 0.
    HIGH = WSP * BARC_HIGH.
  ELSE.
   err1 = 'ERROR: BARC_HIGH is either negativ or 0: '.
   err2 = barc_high.
   err3 = '  I am going to set it automatically to the value "10 mm". '.
   err4 = '  Contact the ADMINISTRATOR for correcting this problem.'.
   concatenate err1 err2 err3 err4 into err.
   if $error_handling = 0.
     message err type mtype.
   endif.
   Err_Code = 1.
   err_val = err.
   high = ( 10 * res ) div '25.4' .
  ENDIF.
  IF LENGTH ge 0.
    LEN  = WSP * LENGTH.
  ELSE.
    err1 = 'ERROR: LENGTH is negative: '.
    err2 = length.
    err3 = '  I am going to set it automatically to the value "0 mm". '.
    err4 = '  Contact the administrator for correcting this problem.'.
    concatenate err1 err2 err3 err4 into err.
    if $error_handling = 0.
      message err type mtype.
    endif.
    Err_Code = 1.
    err_val = err.
    LEN = 0 .
  ENDIF.
  IF MARGIN ge 0.
    MARG = WSP * MARGIN.
  ELSE.
    err1 = 'ERROR: MARGIN is negative: '.
    err2 = margin.
    err3 = '  I am going to set it automatically to the value "0 mm". '.
    err4 = '  Contact the ADMINISTRATOR for correcting this problem.'.
    concatenate err1 err2 err3 err4 into err.
    if $error_handling = 0.
      message err type mtype.
    endif.
    Err_Code = 1.
    err_val = err.
    MARG = 0 .
  ENDIF.
  IF OFFSET ge 0.
    OFFSET1 = WSP * OFFSET.
  ELSE.
    err1 = 'ERROR OFFSET is negative: '.
    err2 = offset.
    err3 = '  I am going to set it automatically to the value "0 mm". '.
    err4 = '  Contact the administrator for correcting this problem.'.
    concatenate err1 err2 err3 err4 into err.
    if $error_handling = 0.
      message err type mtype.
    endif.
    Err_Code = 1.
    err_val = err.
    OFFSET1 = 0 .
  ENDIF.

  IF ( $ROT eq 0 ) or ( $ROT eq 90 )
    or ( $ROT eq 180 ) or ( $ROT eq 270 ).
    ROT = $ROT.
  ELSE.
    err1 = 'ERROR ROT has a wrong value: '.
    err2 = $rot.
    err3 = '  I am going to set it automatically to the value "0". '.
    err4 = '  Contact the ADMINISTRATOR for correcting this problem.'.
    concatenate err1 err2 err3 err4 into err.
    if $error_handling = 0.
      message err type mtype.
    endif.
    Err_Code = 1.
    err_val = err.
    ROT = 0 .
  ENDIF.
* lets make rotation direction compatible with PCL
  IF $ROT = 90.
    ROT = 270.
  ELSEIF $ROT = 270.
    ROT = 90.
  ENDIF.


  SIGN = $SIGN.
  IF NOT ( SIGN BETWEEN 0 AND 8 ).
    err1 = 'ERROR: Wrong SIGN value: '.
    err2 = sign.
    err3 = '  I am going to set it automatically to "0". '.
    err4 = '  Contact the ADMINISTRATOR for correcting this problem. '.
    concatenate err1 err2 err3 err4 into err.
    if $error_handling = 0.
      message err type mtype.
    endif.
    ERR_CODE = 1.
    ERR_VAL = err.
    SIGN = 0.                     "-ERROR-- niedozwola warto## SIGN
  ENDIF.
  data: $barcode(10).
  $barcode = barcode.
  translate $barcode to upper case.
  if $barcode = '128FREE'.
    value = ''.
    loop at 128table.
      if 128Table-DataType = 'T'.
        concatenate value 128Table-128value into value.
      endif.
    endloop.
    REPLACE ALL OCCURRENCES OF '' IN value WITH ' '.
    replace all occurrences of '' in value with space.
  else.
   VALUE = $VALUE.
  endif.
  IF VALUE = ''.
    err1 = 'FATAL ERROR: No encoding value (empty). '.
    err2 = '  I am going to set it automatically to "0". '.
    err3 = '  Contact the ADMINISTRATOR for correcting this problem. '.
    concatenate err1 err2 err3 into err.
    if $error_handling = 0.
      message err type mtype.
    endif.
    ERR_CODE = 2.
    ERR_VAL = err.
    VALUE = '0'.                  "-ERROR-- pusty napis do kodowania
  ENDIF.

  B = $B.
  BB = $BB.
  BBB = $BBB.
  BBBB = $BBBB.
  W = $W.
  WW = $WW.
  WWW = $WWW.
  WWWW = $WWWW.

  IF ( B le 0 ) or ( BB lt 0 ) or ( BBB lt 0 ) or ( BBBB lt 0 )
      or ( W lt 0 ) or ( WW lt 0 ) or ( WWW lt 0 ) or ( WWWW lt 0 ).
    err1 = 'ERROR: either the first bar (B) is NOT > 0  '.
    err2 = '  or any other bar or sapce width is neagatve. '.
    err3 = '  I am going to set B = 10 and other bars to autom. calc.'.
    err4 = '  Contact the ADMINISTRATOR for correcting this problem. '.
    concatenate err1 err2 err3 err4 into err.
    if $error_handling = 0.
      message err type mtype.
    endif.
    err_code = 1.
    err_val = err.
    ERR_CODE = 2.
    ERR_VAL = ''.
    B = 10.
    BB = 0.
    BBB = 0.
    BBBB = 0.
    W = 0.
    WW = 0.
    WWW = 0.
    WWWW = 0.
  ENDIF.
*------------- wywolanie funkcji kodujacych

  if ( input_handling = 2 ) or ( input_handling = 9 ).
    condense value no-gaps.
  endif.
  if ( input_handling = 1 ) or ( input_handling = 9 ).
    shift value left deleting leading '0'.
  endif.
  if value ne ''.
    PERFORM CHOOSE_BARCODE USING BARCODE W_CHKSUM
           CHANGING C CC X XX
           VALUE TBCODE ID CODE TAIL CHKS FSTR ERR_CODE ERR_VAL.
    gchecksum = chks.
  endif.
  data: cl, lc type i, cdc type i.

  if err_code = 2.
    len = 0.
    marg = 0.
    offset1 = 0.
    B = 72.
    Code = 'BBBBBBBBBB'.
    if tail ne ''.
      tail = 'BB'.
    endif.
    if hde eq 1.
      mtype = 'S'.
    endif.
    if $error_handling lt 2.
      message err_val type mtype.
    endif.
* to turn on for test reasons on productive systems
* in this case the table ZRBARC must be created
* before manually.
*
*    if $error_handling eq 3.
*     zrbarc-BDate = sy-datum.
*     zrbarc-BTime = sy-uzeit.
*     zrbarc-BUser = sy-uname.
*     zrbarc-BarcID = st_text_name.
*     zrbarc-symbology = symbology.
*     zrbarc-encoding = encoding.
*     zrbarc-BarcName = smv1.
*     zrbarc-BarNameL = strlen( smv1 ).
*     insert zrbarc.
*    endif.
  endif.

*  if $error_handling eq 4.
*   zrbarc-BDate = sy-datum.
*   zrbarc-BTime = sy-uzeit.
*   zrbarc-BUser = sy-uname.
*   zrbarc-BarcID = st_text_name.
*   zrbarc-symbology = symbology.
*   zrbarc-encoding = encoding.
*   zrbarc-BarcName = smv1.
*   zrbarc-BarNameL = strlen( smv1 ).
*   insert zrbarc.
*  endif.

***********************************************************************
* Barcode as Graphic***************************************************
***********************************************************************

 Br = ( B * res ) / 720 .
    if Br = 0.
      Br = 10.
    endif.
    if BB = 0.
      BBr = Br * 2.
    else.
      BBr = ( BB * Br ) / B.
    endif.
    if BBB = 0.
      BBBr = Br * 3.
    else.
      BBBr = ( BBB * Br ) / B.
    endif.
    if BBBB = 0.
      BBBBr = Br * 4.
    else.
      BBBBr = ( BBBB * Br ) / B.
    endif.

    Wr = ( W *  res ) / 720 .
    if Wr = 0.
      Wr = Br.
    endif.
    if WW = 0.
      WWr = Wr * 2.
    else.
      WWr = ( WW * Wr ) / W.
    endif.
    if WWW = 0.
      WWWr = Wr * 3.
    else.
      WWWr = ( WWW * Wr ) / W.
    endif.
    if WWWW = 0.
      WWWWr = Wr * 4.
    else.
      WWWWr = ( WWWW * Wr ) / W.
    endif.
*------- GRUBE PASKI ------
  C = BBB. CC = BBBB.
  X = WWW. XX = WWWW.
*--------------------------




*    HIGH = WSP * $BARC_HIGH.
    bitmap_header = 'FF'."dummy
    PERFORM GEN_BC_BITMAP
          using
             CODE
             Br BBr BBBr BBBBr
             Wr WWr WWWr WWWWr
             ROT
          changing
             c_exp
             c_len.
***********************************************************************

    if tail ne space.           "important for EAN/UPC
      PERFORM GEN_BC_BITMAP
         using
            tail
            Br BBr BBBr BBBBr
            Wr WWr WWWr WWWWr
            ROT
         CHANGING
            t_exp
            t_len.

       sbb = ( 3 * res ) div '25.4'.   "space between main bc a. addon
       do sbb times.
         concatenate sbb_x '0' into sbb_x.
       enddo.
       sbb_xl = strlen( sbb_x ).
       if ( rot = 0 ) or ( rot = 90 ).
         concatenate c_exp sbb_x t_exp into gc_exp.
       else.
         concatenate t_exp sbb_x c_exp into gc_exp.
       endif.
       gc_len = c_len + sbb + t_len.
     else.
       gc_exp = c_exp.
       gc_len = c_len.
     endif.


     if marg gt 0.
       margin_pix = marg.
       if margin_pix = 0.
         margin_pix = ( res div 75 ).
       endif.
       offset_pix = offset1.
       if offset_pix = 0.
         offset_pix = 5.
       endif.
       if margin_pix gt high.
         margin_pix = high div 2.
       endif.
     else.
       margin_pix = 0.
       offset_pix = 0.
     endif.

*** Embedding caclulation

*** for UPC-A
   if marg gt 0.
     if Barcode cs 'UPC-A'.
      er_cnt = br * 42. "bei UPC 6 Zeichen  7 Module
      do er_cnt times.
        concatenate er_exp '0' into er_exp.
      enddo.
      write gc_exp to marg_exp.
      if ( rot = 0 ) or ( rot =  90 ).
        Offs = br * 6.
        write er_exp to marg_exp+offs(er_cnt).
        offs = offs + er_cnt + br * 4.
        write er_exp to marg_exp+offs(er_cnt).
      else.
        Offs = t_len + sbb_xl + br * 6.
        write er_exp to marg_exp+offs(er_cnt).
        offs = offs + er_cnt + br * 4.
        write er_exp to marg_exp+offs(er_cnt).
      endif.

*** for UPC-E
     elseif Barcode cs 'UPC-E'.
      er_cnt = br * 42. "bei UPC 6 Zeichen  7 Module
      do er_cnt times.
        concatenate er_exp '0' into er_exp.
      enddo.
      write gc_exp to marg_exp.
      if ( rot = 0 ) or ( rot =  90 ).
        Offs = br * 6.
        write er_exp to marg_exp+offs(er_cnt).
      else.
        Offs = t_len + sbb_xl + br * 6.
        write er_exp to marg_exp+offs(er_cnt).
      endif.

*** for EAN-13
     elseif Barcode cs 'EAN-13'.
      er_cnt = br * 42. "bei UPC 6 Zeichen  7 Module
      do er_cnt times.
        concatenate er_exp '0' into er_exp.
      enddo.
      write gc_exp to marg_exp.
      if ( rot = 0 ) or ( rot =  90 ).
        Offs = br * 6.
        write er_exp to marg_exp+offs(er_cnt).
        offs = offs + er_cnt + br * 4.
        write er_exp to marg_exp+offs(er_cnt).
      else.
        Offs = t_len + sbb_xl + br * 6.
        write er_exp to marg_exp+offs(er_cnt).
        offs = offs + er_cnt + br * 4.
        write er_exp to marg_exp+offs(er_cnt).
      endif.

     elseif Barcode cs 'EAN-8'.
      er_cnt = br * 28. "bei UPC 4 Zeichen  7 Module
      do er_cnt times.
        concatenate er_exp '0' into er_exp.
      enddo.
      write gc_exp to marg_exp.
      if ( rot = 0 ) or ( rot =  90 ).
        Offs = br * 6.
        write er_exp to marg_exp+offs(er_cnt).
        offs = offs + er_cnt + br * 4.
        write er_exp to marg_exp+offs(er_cnt).
      else.
        Offs = t_len + sbb_xl + br * 6.
        write er_exp to marg_exp+offs(er_cnt).
        offs = offs + er_cnt + br * 4.
        write er_exp to marg_exp+offs(er_cnt).
      endif.

     else.
*** for other BCs  *********************************************
       er_cnt = c_len - ( 2 * offset_pix ). "bei UPC 6
                                                  "Zeichen  7
       do er_cnt times.
         concatenate er_exp '0' into er_exp.
       enddo.
       write c_exp to marg_exp.

         write er_exp to marg_exp+offset_pix(er_cnt).
       endif.
     endif.

*** Top erasment caclulation for UPC/EAN addons.

     if t_len gt 0.
       er_exp = ''.
       write gc_exp to top_exp.
       do t_len times.
         concatenate er_exp '0' into er_exp.
       enddo.
       if ( rot = 0 ) or ( rot = 90 ).
         Offs = c_len + sbb_xl.
       else.
         Offs = 0.
       endif.
       write er_exp to top_exp+Offs(t_len).
     endif.

     if len gt 0.  "indication for dot terminator
       bterm = 'Y'.
     endif.
     if bterm = 'Y'.
      if res lt 76.
        eads_w = '0000'.
        eads_s = '0011'.
        btermh = 4.
      elseif ( ( res gt 75 ) and ( res lt 151 ) ).
        eads_w = '00000000'.
        eads_s = '00001111'.
        btermh = 8.
      elseif ( ( res gt 150 ) and ( res lt 301 ) ).
        eads_w = '0000000000000000'.
        eads_s = '0000000011111111'.
        btermh = 16.
     else.
        eads_w = '00000000000000000000000000000000'.
        eads_s = '00000000000000001111111111111111'.
        btermh = 32.
     endif.

     write gc_exp to gc_exp_save.
     if marg eq 0.
       concatenate gc_exp eads_s into term_exp.
       body_h = high.
     else.
       concatenate gc_exp_save eads_w into gc_exp.
       if t_len gt 0.
         concatenate top_exp eads_w into top_exp.
       endif.
       concatenate marg_exp eads_s into term_exp.
       concatenate marg_exp eads_w into marg_exp.
     endif.
     concatenate gc_exp_save eads_w into gc_exp.
     data: a1 type i, a2 type i, a3 type i, a4 type i.
     a1 = strlen( gc_exp ).
     a2 = strlen( top_exp ).
     a3 = strlen( marg_exp ).
     a4 = strlen( term_exp ).
     gc_len = strlen( gc_exp ).
   endif.

*** assuming the high of each line type *********
   if t_len eq 0.
     top_h = 0.
   else.
     top_h = margin_pix.
   endif.
   if marg gt 0.
     marg_h = margin_pix - btermh.
     if marg_h lt 0.
       body_h = body_h + marg_h.
       marg_h = 0.
     endif.
   endif.
   term_h = btermh.
   body_h = high - top_h - marg_h - term_h.
*************************************************
*** well, now we have:
*** top_exp  top_h
*** gc_exp   body_h
*** marg_exp  marg_h
*** term_exp  term_h
* if rot was on, the lines are already rotated
*************************************************

  IF g_type = '<0BMP>'.
   SY-TVAR8 = 1. "88888




    bit_len_orig = gc_len.


      if ( rot =  0 ) or ( rot = 180 ).

        padding = 32 - ( bit_len_orig mod 32 ).
        if padding = 32.
           padding = 0.
        endif.
        bit_len = bit_len_orig + padding.
        do padding times.
          concatenate gc_exp '0' into gc_exp.
          if marg_h gt 0.
             concatenate marg_exp '0' into marg_exp.
             if top_h gt 0.
               concatenate top_exp '0' into top_exp.
             endif.
           endif.
           if term_h gt 0.
             concatenate term_exp '0' into term_exp.
           endif.
        enddo.

        perform make_bitmap_hex
              using gc_exp
              changing gc_hex.
        if marg_h gt 0.
           perform make_bitmap_hex
                 using marg_exp
                 changing marg_hex.
           if top_h gt 0.
             perform make_bitmap_hex
                    using  top_exp
                    changing top_hex.
           endif.
        endif.

        if term_h gt 0.
          perform make_bitmap_hex
                using term_exp
                changing term_hex.
        endif.
        perform complete_bitmap_neu
           using
            bitmap_header
            top_hex
            top_h
            gc_hex
            body_h
            marg_hex
            marg_h
            term_hex
            term_h
            rot.
      else.  "if rot = 90 or rot = 270.
        padding = 32 - ( high mod 32 ).
        if padding = 32.
           padding = 0.
        endif.

        bit_len = high.
        high = bit_len_orig.

        4bytes = bit_len div 32.
        do 4bytes times.
          concatenate gc_hex_1 'FFFFFFFF' into gc_hex_1.
          concatenate gc_hex_0 '00000000' into gc_hex_0.
        enddo.
        rest = bit_len - ( 4bytes * 32 ).
        halfbyte = rest div 4.
        bcende = ( 4bytes * 8 ) + halfbyte.
        do halfbyte times.
          concatenate gc_hex_1 'F' into gc_hex_1.
          concatenate gc_hex_0 '0' into gc_hex_0.
        enddo.
        if rest > 0.
           rest = 8 - halfbyte.
           do rest times.
              concatenate gc_hex_1 '0' into gc_hex_1.
              concatenate gc_hex_0 '0' into gc_hex_0.
           enddo.
           bit_len = bit_len + padding.
           gc_hex_len = strlen( gc_hex_1 ).
        endif.


        if marg_h gt 0.
          marg_exp_rot = ''.
          do marg_h times.
           concatenate marg_exp_rot '0' into marg_exp_rot.
          enddo.
          rest = marg_h mod 4.
          do rest times.
           concatenate marg_exp_rot '0' into marg_exp_rot.
          enddo.
          perform make_bitmap_hex
                using marg_exp_rot
                changing marg_hex.
          marg_hex_len = strlen( marg_hex ).
          endif.




          if rot = 90.
            Offs_m = 0.
            Offs_t = gc_hex_len - marg_hex_len.
          else.
            Offs_m = bcende - marg_hex_len.
            Offs_t = 0.
          endif.
          do bit_len_orig times.
            r_body = gc_exp.
            r_marg = marg_exp.
            r_top = top_exp.
            if r_body = '1'.
            gc_hex = gc_hex_1.
            if r_marg = '0'.
              write marg_hex to gc_hex+offs_m(marg_hex_len).
            endif.
            if r_top = '0'.
              write marg_hex to gc_hex+offs_t(marg_hex_len).
            endif.
            else.
              gc_hex = gc_hex_0.
            endif.
*  Int table for debugging.
*            dbitmap-l = gc_hex.
*            append dbitmap.
            concatenate bm_rot gc_hex into bm_rot. "new
            shift gc_exp.
            shift marg_exp.
            shift top_exp.

          enddo.


          gc_hex = ''.
          gc_exp_rot = ''.

        perform complete_bitmap_rot
        using
           bitmap_header
           bm_rot
           bit_len
        changing
           last_row.
      endif.

   data: bitmap_bytecnt type i, high_save type i.

   bytes_per_row = bit_len div 8.
   bitmap_bytecnt = ( bytes_per_row * high ) + 64.
   bitmap_len = bytes_per_row * 8.


   perform enable_bitmap
           using smv1 res bitmap_bytecnt bit_len high."text_name.

************************************************************************
* Barcode as BMP Graphic END *******************************************
************************************************************************
  ELSEIF g_type = '<0OTF>'.

************************************************************************
* Barcode as OTF Graphic************************************************
************************************************************************
    SY-TVAR8 = 2.
    bit_len_orig = gc_len.

      if ( rot =  0 ) or ( rot = 180 ).

        padding = 32 - ( bit_len_orig mod 32 ).
        if padding = 32.
           padding = 0.
        endif.
        bit_len = bit_len_orig + padding.
        do padding times.
          concatenate gc_exp '0' into gc_exp.
          if marg_h gt 0.
             concatenate marg_exp '0' into marg_exp.
             if top_h gt 0.
               concatenate top_exp '0' into top_exp.
             endif.
           endif.
           if term_h gt 0.
             concatenate term_exp '0' into term_exp.
           endif.
        enddo.

        perform make_bitmap_hex
              using gc_exp
              changing gc_hex.
        if marg_h gt 0.
           perform make_bitmap_hex
                 using marg_exp
                 changing marg_hex.
           if top_h gt 0.
             perform make_bitmap_hex
                    using  top_exp
                    changing top_hex.
           endif.
        endif.

        if term_h gt 0.
          perform make_bitmap_hex
                using term_exp
                changing term_hex.
        endif.

        perform gen_bc_bitmap_header_otf
           using
              bit_len   "after adding pads
              bit_len_orig "befor padding
              HIGH
              ROT
              RES
           changing
              bitmap_header.


        perform complete_bitmap_otf
              using
              bitmap_header
              top_hex
              top_h
              gc_hex
              body_h
              marg_hex
              marg_h
              term_hex
              term_h
              rot
             changing
              last_row.
   else. "if rot = 90 or rot = 270

        padding = 32 - ( high mod 32 ).
        if padding = 32.
           padding = 0.
        endif.
data bit_len_ap type i.
        bit_len = high.
        bit_len_ap = bit_len + padding. "after padding
        high = bit_len_orig.

        perform gen_bc_bitmap_header_otf
           using
              bit_len_ap   "after adding pads
              bit_len "befor padding
              HIGH
              ROT
              RES
           changing
              bitmap_header.

        4bytes = bit_len div 32.
        do 4bytes times.
          concatenate gc_hex_1 'FFFFFFFF' into gc_hex_1.
          concatenate gc_hex_0 '00000000' into gc_hex_0.
        enddo.
        rest = bit_len - ( 4bytes * 32 ).
        halfbyte = rest div 4.
        bcende = ( 4bytes * 8 ) + halfbyte.
        do halfbyte times.
          concatenate gc_hex_1 'F' into gc_hex_1.
          concatenate gc_hex_0 '0' into gc_hex_0.
        enddo.
        if rest > 0.
           rest = 8 - halfbyte.
           do rest times.
              concatenate gc_hex_1 '0' into gc_hex_1.
              concatenate gc_hex_0 '0' into gc_hex_0.
           enddo.
           bit_len = bit_len + padding.
           gc_hex_len = strlen( gc_hex_1 ).
        endif.


        if marg_h gt 0.
          marg_exp_rot = ''.
          do marg_h times.
           concatenate marg_exp_rot '0' into marg_exp_rot.
          enddo.
          rest = marg_h mod 4.
          do rest times.
           concatenate marg_exp_rot '0' into marg_exp_rot.
          enddo.
          perform make_bitmap_hex
                using marg_exp_rot
                changing marg_hex.
          marg_hex_len = strlen( marg_hex ).
          endif.

          if rot = 90.
            Offs_m = 0.
            Offs_t = gc_hex_len - marg_hex_len.
          else.
            Offs_m = bcende - marg_hex_len.
            Offs_t = 0.
          endif.

          do bit_len_orig times.
            r_body = gc_exp.
            r_marg = marg_exp.
            r_top = top_exp.
            if r_body = '1'.
            gc_hex = gc_hex_1.
            if r_marg = '0'.
              write marg_hex to gc_hex+offs_m(marg_hex_len).
            endif.
            if r_top = '0'.
              write marg_hex to gc_hex+offs_t(marg_hex_len).
            endif.
            else.
              gc_hex = gc_hex_0.
            endif.
*  Int table for debugging.
*            dbitmap-l = gc_hex.
*            append dbitmap.
            concatenate bm_rot gc_hex into bm_rot. "new
            shift gc_exp.
            shift marg_exp.
            shift top_exp.
          enddo.

          gc_hex = ''.
          gc_exp_rot = ''.

        perform complete_bitmap_rot_otf_neu
        using
           bitmap_header
           bm_rot
        changing
           last_row.
      endif.


Data: X_POS_int type i, X_POS_char(5),
      Y_POS_int type i, Y_POS_char(5), spmunit(5), uc_unit(4).

    x_pos_int = xposition.
    x_pos_char = x_pos_int.
    y_pos_int = yposition.
    y_pos_char = y_pos_int.
    uc_unit = st.
    translate uc_unit to upper case.
    if uc_unit = 'MM'.
       spmunit = ' MM'.
    elseif uc_unit = 'CM'.
       spmunit = ' CM'.
    elseif uc_unit = 'INCH'.
       spmunit = ' INCH'.
    endif.


    REFRESH LINES.

    LINES-TDFORMAT = '/:'.
    if d1 = 1.
       LINES-TDLINE = 'HEX TYPE BMON HEIGHT 0000 CM LEFT '.
       concatenate lines-tdline x_pos_char spmunit
                                      into lines-tdline.
    else.
       concatenate 'HEX TYPE BMON XPOS '
                    x_pos_char
                    spmunit
                    ' YPOS '
                    y_pos_char
                    spMUNIT
      into lines-tdline.

    endif.

    append lines.

    perform make_bitmap_otf tables lines.

    IF last_row <> ''.
       LINES-TDFORMAT = '/='.
       LINES-TDLINE = last_row.
       Append lines.
    ENDIF.
    LINES-TDFORMAT = '/:'.
    LINES-TDLINE = 'ENDHEX'.
    append lines.


    HEADER-TDNAME = SMV1.
    HEADER-TDOBJECT = 'TEXT'.
    HEADER-TDID = 'ADRS'.
    HEADER-TDSPRAS = SY-LANGU.
    HEADER-TDLINESIZE = 132.
Data: save_result.

    CALL FUNCTION 'SAVE_TEXT'
      EXPORTING
        CLIENT          = SY-MANDT
        HEADER          = HEADER
        INSERT          = 'X'
        SAVEMODE_DIRECT = 'X'
      IMPORTING
        FUNCTION        = save_result
      TABLES
        LINES           = LINES
      EXCEPTIONS
        ID              = 1
        LANGUAGE        = 2
        NAME            = 3
        OBJECT          = 4
        OTHERS          = 5.
    HEADER-TDLINESIZE = 132.

* how high was the bitmap?
    if ( rot = 0 ) or ( rot = 180 ).
       smv2 = high div ( res div 6 ).
       high = high mod ( res div 6 ).
       if high > 0.
          smv2 = smv2 + 1.
       endif.
    else.
       smv2 = bit_len div ( res div 6 ).
       bit_len = bit_len mod ( res div 6 ).
       if bit_len > 0.
          smv2 = smv2 + 1.
       endif.
    endif.
    refresh lines.
************************************************************************
* Barcode as Graphic END ***********************************************
************************************************************************

  ELSE.


*----- WYPE#NIANIE TABELI LINES
    REFRESH LINES.
    LINES-TDFORMAT = '/:'.
    LINES-TDLINE = 'HEX TYPE PCL'.
    APPEND LINES.
    LINES-TDFORMAT = '/='.
*--------- POZYCJONOWANIE BEZWZGLEDNE
    IF D1 NE 0.
      IF XPOS < 0.
        XPOS = - XPOS.
        POZYCJONUJ_WZGL 'x' 'm' XPOS.
      ELSEIF XPOS > 0.
        POZYCJONUJ_WZGL 'x' 'p' XPOS.
      ENDIF.
      IF YPOS < 0.
        YPOS = - YPOS.
        POZYCJONUJ_WZGL 'y' 'm' YPOS.
      ELSEIF YPOS > 0.
        POZYCJONUJ_WZGL 'y' 'p' YPOS.
      ENDIF.
    ELSEIF XPOS NE 0 AND YPOS NE 0.
      POZYCJONUJ XPOS YPOS.
    ENDIF.
*--------- ROTACJA
    CASE ROT.
      WHEN 90.
        PISZ_HEX '1B2661393050'.
      WHEN 180.
        PISZ_HEX '1B266131383050'.
      WHEN 270.
        PISZ_HEX '1B266132373050'.
    ENDCASE.
*----------- Sprawdzenie czy nie ma b##du
    IF ERR_CODE = 0.
*------------ Uzupelnienie konieczne by pozycja kursora byla na dole
      POZYCJONUJ_WZGL 'y' 'm' HIGH.
*--------- PUSH CURSOR
      IF SIGN > 0.
        PUSH_CURSOR.
        IF SIGN > 4.
*        push_cursor.
        ENDIF.
      ENDIF.
*    IF XPOS = 0 AND YPOS = 0.
*      PUSH_CURSOR.
*    ENDIF.
*--------- Wgranie makr
      GR = B + W.
      MACRO_DEF '3431' B HIGH GR 'p'.
      GR = B + WW.
      MACRO_DEF '3432' B HIGH GR ' '.
      GR = BB + W.
      MACRO_DEF '3531' BB HIGH GR ' '.
      GR = BB + WW.
      IF ID = '2'.
        MACRO_DEF '3532' BB HIGH GR 'l'.
      ELSE.
        MACRO_DEF '3532' BB HIGH GR ' '.
        GR = B + X.
        MACRO_DEF '3433' B HIGH GR ' '.
        GR = B + XX.
        MACRO_DEF '3434' B HIGH GR ' '.
        GR = BB + X.
        MACRO_DEF '3533' BB HIGH GR ' '.
        GR = BB + XX.
        MACRO_DEF '3534' BB HIGH GR ' '.
        GR = C + W.
        MACRO_DEF '3631' C HIGH GR ' '.
        GR = C + WW.
        MACRO_DEF '3632' C HIGH GR ' '.
        GR = C + X.
        MACRO_DEF '3633' C HIGH GR ' '.
        GR = C + XX.
        MACRO_DEF '3634' C HIGH GR ' '.
        GR = CC + W.
        MACRO_DEF '3731' CC HIGH GR ' '.
        GR = CC + WW.
        MACRO_DEF '3732' CC HIGH GR ' '.
        GR = CC + X.
        MACRO_DEF '3733' CC HIGH GR ' '.
        GR = CC + XX.
        MACRO_DEF '3734' CC HIGH GR 'l'.
      ENDIF.
*--------- Rysowanie paska
      DRAW_BARCODE CODE.
      BARLEN_NO_TAIL = BARLEN - W.
      IF TAIL NE ''.
        YPOS1 = 0.
        GAP = '2.23' * CC.
        BARLEN = BARLEN + GAP.
        IF SIGN = 7 OR SIGN = 8.
          YPOS1 = 2 * MARG.
        ELSEIF SIGN = 5 OR SIGN = 6.
          YPOS1 = MARG.
        ENDIF.
        POZYCJONUJ_WZGL 'x' 'p' GAP.
        HIGH1 = HIGH - YPOS1.
        DRAW_BARCODE TAIL.
        XPOS1 = BARLEN - BARLEN_NO_TAIL - GAP.
        POZYCJONUJ_WZGL 'x' 'm' XPOS1.
        IF YPOS1 > 0.
          PROSTOKAT XPOS1 YPOS1 '763150'.
        ENDIF.
      ENDIF.
* ----------- Podpis ----------
      IF SIGN NE 0.
        L = STRLEN( FSTR ).
* przepisanie ogona do osobnego #a#cucha
        IF TBCODE CS '+2'.
          L = L - 2.
          STR = FSTR+L(2).
          FSTR = FSTR(L).
        ELSEIF TBCODE CS '+5'.
          L = L - 5.
          STR = FSTR+L(5).
          FSTR = FSTR(L).
        ENDIF.
        IF SIGN = 2 OR SIGN = 4 OR SIGN = 6 OR SIGN = 8.
          WRITE CHKS TO FSTR+L.
        ENDIF.
        PERFORM FORMAT_STRING USING MASK CHANGING FSTR.
        BARLEN0 = BARLEN_NO_TAIL.
* Ustawienie czcionki
        DATA: FONT1B(2).
        FONT1B = FONT.
        TRANSLATE FONT1B TO UPPER CASE.
        IF FONT NE '' AND FONT1B <> '1B'.
          LINES-TDLINE = SLINE.
          APPEND LINES.
          LINES-TDFORMAT = '/:'.
          LINES-TDLINE = 'ENDHEX'.
          APPEND LINES.
          LINES-TDFORMAT = '/:'.
          SLINE = 'PRINT-CONTROL'.
          WRITE FONT TO SLINE+14.
          LINES-TDLINE = SLINE.
          APPEND LINES.
          LINES-TDLINE = 'HEX TYPE PCL'.
          APPEND LINES.
          LINES-TDFORMAT = '/='.
          SLINE = ''. II = 0.
        ELSE.

          LINES-TDLINE = SLINE.
          APPEND LINES.
          LINES-TDLINE = FONT.
          APPEND LINES.
          LINES-TDFORMAT = '/='.
          SLINE = ''. II = 0.
        ENDIF.


* --------- POP CURSOR
        POP_CURSOR.                      " do wierzcho#ka paska
        XPOS1 = 0.
        CASE SIGN.
          WHEN 1 OR 2.
            YPOS1 = HIGH + MARG.
            POZYCJONUJ_WZGL 'y' 'p' YPOS1.
          WHEN 3 OR 4.
            POZYCJONUJ_WZGL 'y' 'm' MARG.
          WHEN 5 OR 6 OR 7 OR 8.         "embeded
*------- WYMAZUJACY PROSTOKACIK
            PERFORM BLANK_REC USING TBCODE 0 B BB C CC W WW X XX
                                     HIGH MARG LEN
                              CHANGING XPOS1 YPOS1 BARLEN0
                                       XPOS2 YPOS2 BARLEN1
                                       P K.
            POZYCJONUJ_WZGL 'x' 'p' XPOS1.
            POZYCJONUJ_WZGL 'y' 'p' YPOS1.
            GR = MARG + 10.
            PROSTOKAT BARLEN0 GR '763150'.
            IF BARLEN1 NE 0.
              POZYCJONUJ_WZGL 'x' 'p' XPOS2.
              PROSTOKAT BARLEN1 GR '763150'.
              POZYCJONUJ_WZGL 'x' 'm' XPOS2.
            ENDIF.
* POZYCJONOWANIE PODPISU
            IF SIGN > 6.
              GR = MARG * 2.
              POZYCJONUJ_WZGL 'y' 'p' GR.
            ELSE.
              POZYCJONUJ_WZGL 'y' 'p' MARG.
            ENDIF.
        ENDCASE.
        IF TAIL NE ''.
          PUSH_CURSOR.
        ENDIF.
        IF OFFSET1 > 0.
          POZYCJONUJ_WZGL 'x' 'p' OFFSET1.
        ELSEIF OFFSET1 < 0.
          POZYCJONUJ_WZGL 'x' 'm' OFFSET1.
        ENDIF.
        PISZ FSTR.
        IF TAIL NE ''.                   " dopisanie ogona
          POP_CURSOR.
          XPOS1 = BARLEN_NO_TAIL + GAP - P + B + W + BB.
          POZYCJONUJ_WZGL 'x' 'p' XPOS1.
          IF SIGN > 4.
            YPOS1 = HIGH1.
            IF SIGN < 7.
              YPOS1 = YPOS1 + MARG / 4.
            ELSE.
              YPOS1 = YPOS1 + '1.5' * MARG.
            ENDIF.
            POZYCJONUJ_WZGL 'y' 'm' YPOS1.
          ENDIF.
          PISZ STR.
        ENDIF.
      ENDIF.


*------ W przypadku gdy pojawi si# b##d
    ELSE.
      FSTR = 'ERR. No '.
      WRITE ERR_CODE TO FSTR+8 USING EDIT MASK 'LL___'.
      PISZ FSTR.
      CASE ERR_CODE.
        WHEN 1.
          FSTR = ': Wrong bar code typ'.
        WHEN 2.
          FSTR = ': Encoding string is empty'.
        WHEN 3.
          FSTR = ': Wrong lenght of encoding string'.
        WHEN 4.
          FSTR = ': Error in char. range'.
        WHEN 5.
          FSTR = ': Value <ROT>'.
        WHEN 6.
          FSTR = ': Value <Sign>'.
        WHEN 7.
          FSTR = ': Value <Text_ID>'.
        WHEN 8.
          FSTR = ': Value <Unit>'.
        WHEN 9.
         FSTR =  ': Value <barc_high>, <xpos>, <ypos>, <marg> or <len>'.
        WHEN 10.
          FSTR =  ': Value <b/w>, <bb/ww>, <bbb/www>, <bbbb/wwwww>'.
        WHEN 11.
          FSTR =  ': Unexpected error'.
      ENDCASE.
      PISZ FSTR.

    ENDIF.
*------- odwrocenie ukladu wsp
    IF ROT > 0.
      PISZ_HEX '1B26613050'.
    ENDIF.
*--------- KONIEC TEKSTU
    LINES-TDLINE = SLINE.
    APPEND LINES.
    LINES-TDFORMAT = '/:'.
    LINES-TDLINE = 'ENDHEX'.
    APPEND LINES.

*  LINES-TDFORMAT = '*'.
*  LINES-TDLINE = 'Meine Leine'.
*  APPEND LINES.

*  IF XPOS = 0 AND YPOS = 0.
*    LINES-TDFORMAT = '*'.
*    LINES-TDLINE = 'HA1HA1HA1'.
*    APPEND LINES.
*    LINES-TDFORMAT = '/:'.
*    LINES-TDLINE = 'PRINT-CONTROL YPOPC'.
*    APPEND LINES.
*  ENDIF.
*-------------------------------------------------------------------*
*DATA: SYTVAR0(20).

    HEADER-TDNAME = SMV1.
    HEADER-TDOBJECT = 'TEXT'.
    HEADER-TDID = 'ST'.
    HEADER-TDSPRAS = SY-LANGU.
    HEADER-TDLINESIZE = 132.


    CALL FUNCTION 'SAVE_TEXT'
      EXPORTING
        CLIENT          = SY-MANDT
        HEADER          = HEADER
        INSERT          = ' '
        SAVEMODE_DIRECT = 'X'
      TABLES
        LINES           = LINES
      EXCEPTIONS
        ID              = 1
        LANGUAGE        = 2
        NAME            = 3
        OBJECT          = 4
        OTHERS          = 5.


  ENDIF.
ENDFORM.                               "barc_ss
*-------------- end


INCLUDE ZRBARC_12.